{% load staticfiles %}
{% load static %}

{% block extra_stylesheet %}
<!-- ================== BEGIN DATERANGE CSS ================== -->
<link href="{% static 'assets/plugins/bootstrap-daterangepicker/daterangepicker.css' %}" rel="stylesheet" />
<!-- ================== END DATERANGE CSS ================== -->
<style type="text/css">
    .filtros{
        display: none;

    }
</style>
{% endblock extra_stylesheet %}

<!-- ========================== HEADER ========================== -->

<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
	<li class="breadcrumb-item active"><span class="fecha"></span></li>
</ol>
<!-- end breadcrumb -->
<!-- begin page-header -->
<h1 class="page-header"></h1>
<!-- end page-header -->

<!-- ========================== ENDHEADER ========================== -->

{% block container %}


<div class="filtros" id="container_ppal">


    <!-- begin panel -->
    <div class="panel panel-inverse">
        <!-- begin panel-heading -->
        <div class="panel-heading">
            <h4 class="panel-title"></h4>
            <div class="panel-heading-btn">
                <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
                <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
                <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
                
            </div>
        </div>
        <!-- end panel-heading -->

        <!-- begin panel-body -->
        <div class="panel-body">
            <div class="form-group row">

                <div class="col align-self-cente">
                    <div class="input-group input-daterange">
                    <input type="text" class="form-control" name="start" id="customDate" placeholder="Fecha Inicial" />
                    <span class="input-group-addon"><i class="fa fa-calendar"></i></span>
                    </div>
                </div>
            </div>

            <hr class="divider"></hr>
            <div class="form-group row">
                <div class="col align-self-cente">
                    <h4 class="text-center text-warning">
                       <i class="fa fa-chart-bar"></i>&nbsp;&nbsp; Gráfico por status
                    </h4>
                </div>
            </div>
            <hr class="divider"></hr>
            <div class="form-group row">
                <div class="col align-self-cente">
                    <div id="chartdiv" style="width: 100%; height: 600px"></div>
                </div>
            </div>
        </div>
        <!-- end panel-body -->
    </div>
    <!-- end panel -->

                        
</div>

{% endblock container %}


{% block extra_javascript %}

<!-- ================== BEGIN DATERANGE JS ================== -->
<script type="text/javascript" src="{% static 'assets/plugins/moment/moment.js' %}"></script>
<script type="text/javascript" src="{% static 'assets/plugins/bootstrap-daterangepicker/daterangepicker.js' %}"></script>
<!-- ================== END DATERANGE JS ================== -->
<script type="text/javascript">
	userInSession();
	titlePage('Home')


//===== LLAMADO INICIAL DEL GRÁFICO =====\\

function start_callback(){
    var startDate = moment().year().toString() + '-01-01';
    var endDate = moment().format('YYYY-MM-DD');

    var params = {
        startDate:startDate,
        endDate:endDate,
    }

    status_por_fecha(params)
}

//===== DATERANGE =====\\
function dateRange(id){
    var start = moment().subtract(29, 'days');
    var end = moment();

    var quarter = moment().quarter();
    // Aquí se inicializa el selector de fechas
    $(id + ' span').html(start.format('MMMM D, YYYY') + ' - ' + end.format('MMMM D, YYYY'));

    //===== TRIMESTRES =====\\
    /******** FORMATO AAAA-MM-DD ********/
    var Q1A = moment().year().toString() + '-01-01'
    var Q1B = moment().year().toString() + '-03-31'

    var Q2A = moment().year().toString() + '-04-01'
    var Q2B = moment().year().toString() + '-06-30'

    var Q3A = moment().year().toString() + '-07-01'
    var Q3B = moment().year().toString() + '-09-30'

    var Q4A = moment().year().toString() + '-10-01'
    var Q4B = moment().year().toString() + '-12-31'

    //===== SEMESTRE =====\\

    var S1A = moment().year().toString() + '-01-01'
    var S1B = moment().year().toString() + '-06-30'

    var S2A = moment().year().toString() + '-07-01'
    var S2B = moment().year().toString() + '-12-31'

    $(id).daterangepicker({
        startDate: start,
        endDate: end,
        showDropdowns: true,
        minDate: '01/01/2001',
        maxDate: '01/01/2099',
        opens: 'right',
		drops: 'down',
		buttonClasses: ['btn', 'btn-sm'],
        applyClass: 'btn-warning',
        cancelClass: 'btn-inverse',
        locale: {
            format: 'DD/MM/YYYY',
            applyLabel: 'Enviar',
            cancelLabel: 'Cancelar',
            fromLabel: 'Desde',
            toLabel: 'Hasta',
            customRangeLabel: 'Seleccionar Fecha',
            todayLabel: 'Hoy',
            daysOfWeek: [
            "Lun",
            "Mar",
            "Mié",
            "Jue",
            "Vie",
            "Sáb",
            "Dom"],
            monthNames: [
            "Enero",
            "Febrero",
            "Marzo",
            "Abril",
            "Mayo",
            "Junio",
            "Julio",
            "Agosto",
            "Septiembre",
            "Octubre",
            "Noviembre",
            "Diciembre"
            ],
            firstDay: 0
        },
        ranges: {
        'Hoy': [moment(), moment()],
        'Mes actual': [moment().startOf('month'), moment().endOf('month')],
        'Últimos 15 días': [moment().subtract(14, 'days'), moment()],
        'Últimos 30 días': [moment().subtract(29, 'days'), moment()],

        'Trimestre 1': [moment(Q1A,'YYYY-MM-DD'), moment(Q1B,'YYYY-MM-DD')],
        'Trimestre 2': [moment(Q2A,'YYYY-MM-DD'), moment(Q2B,'YYYY-MM-DD')],
        'Trimestre 3': [moment(Q3A,'YYYY-MM-DD'), moment(Q3B,'YYYY-MM-DD')],
        'Trimestre 4': [moment(Q4A,'YYYY-MM-DD'), moment(Q4B,'YYYY-MM-DD')],

        'Semestre 1': [moment(S1A,'YYYY-MM-DD'), moment(S1B,'YYYY-MM-DD')],
        'Semestre 2': [moment(S2A,'YYYY-MM-DD'), moment(S2B,'YYYY-MM-DD')],

        'Mes actual': [moment().startOf('month'), moment().endOf('month')],
        'Mes anterior': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')],
        'Año anterior': [moment().subtract(364, 'days'), moment()],//
        }
        });

    //===== PARAMETROS PARA PETICIONES AJAX O AXIOS =====\\

    $(id).on('apply.daterangepicker', function(ev, picker) {
        /*
            MANEJADOR DE EVENTOS PROPIOS DEL DETERANGE, INICIA 
            CUANDO PULSAMOS EL BTN ACEPTAR(APPLY) DEL CALENDARIO
            DESPLEGADO.
        */

        ev.preventDefault()

        var params = {
            startDate:picker.startDate.format('YYYY-MM-DD'),
            endDate:picker.endDate.format('YYYY-MM-DD'),
            } 

        status_por_fecha(params)//PETICION AL SERVER

    })

}

//===== LLAMADOS POSTERIORES =====\\
function status_por_fecha(params){

    /*
        ESTA FUNCIÓN REALIZA UN PETICION PARA CALCULAR EL NUMERO DE CONTRATOS QUE SE HAN
        GENERADO EN EL RANGO DE FECHAS SELECCIONADO.
    */

    //===== 1ERA PETICIÓN AXIOS =====\\
    var conf = {
        headers: { Authorization: 'jwt '+ HDD.get(Django.name_jwt)},
        params:params,
    };
    axios.get('api/v1/home-api?format=json',conf)
    .then(function(response){
        var $data = response.data

        if($data.results == true){

            $(".panel-title").text('Datos obtenidos desde ' + $data.rango.startDate + ' hasta ' + $data.rango.endDate)

        	ColumnasHome($data.status)

        }else{
            _info($data.errorMsj)
        }

    })
    .then(function(){

    })
    .catch(function(e){
        handleErrorAxios(e)
    })
}



// GRAFICO 
/*function ColumnasHome(data){
	// Create chart instance
	var chart = am4core.create("chartdiv", am4charts.XYChart);
	chart.responsive.enabled = true;
	// Add data
	chart.data = data;

	chart.language.locale = am4lang_es_ES;
	chart.numberFormatter.language = new am4core.Language();
	chart.numberFormatter.language.locale = am4lang_es_ES;
	chart.dateFormatter.language = new am4core.Language();
	chart.dateFormatter.language.locale = am4lang_es_ES;

	chart.language.locale["_decimalSeparator"] = ",";
	chart.language.locale["_thousandSeparator"] = "."; 

	// Create axes
	var categoryAxis = chart.xAxes.push(new am4charts.CategoryAxis());
	categoryAxis.dataFields.category = "status";
	categoryAxis.renderer.grid.template.location = 0;

	var valueAxis = chart.yAxes.push(new am4charts.ValueAxis());

	// Create series
	var series = chart.series.push(new am4charts.ColumnSeries());
	series.dataFields.valueY = "nro_servicios";
	series.dataFields.categoryX = "status";
	series.dataFields.categoryZ = "porcentaje";
    series.dataFields.categoryW = "recaudacion";
	series.tooltipText = "[{categoryX}: bold]{valueY}[/]";
	series.columns.template.propertyFields.fill = "color";
	series.columns.template.propertyFields.stroke = "color";
	series.columns.template.column.cornerRadiusTopLeft = 10;
	series.columns.template.column.cornerRadiusTopRight = 10;
	series.columns.template.column.fillOpacity = 0.8;

	var hoverState = series.columns.template.column.states.create("hover");
	hoverState.properties.cornerRadiusTopLeft = 0;
	hoverState.properties.cornerRadiusTopRight = 0;
	hoverState.properties.fillOpacity = 1;
	
	// Cursor
	chart.cursor = new am4charts.XYCursor();

	series.columns.template.events.on("hit", function(ev) {
		swal(Capitalize(ev.target.dataItem.categoryX),"Nro total de servicios : " + SeparateNumber(ev.target.dataItem.valueY)+"\n Porcentaje: "+ SeparateNumber(ev.target.dataItem.categoryZ,'A')+"% \n Recaudación: $ "+SeparateNumber(ev.target.dataItem.categoryW)+"","info");
	}, this);
	
}*/


$(document).ready(function(){


/*    $.when(

        start_callback(),
        dateRange("#customDate")

        ).
    then(function(){
        $("#container_ppal").removeClass('filtros')
    })
*/
})

</script>
{% endblock extra_javascript %}